<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.5.0_17) on Fri Dec 04 18:31:05 CET 2009 -->
<TITLE>
ConcurrentTable
</TITLE>

<META NAME="keywords" CONTENT="ch.javasoft.jbase.concurrent.ConcurrentTable class">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    parent.document.title="ConcurrentTable";
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/ConcurrentTable.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;PREV CLASS&nbsp;
&nbsp;<A HREF="../../../../ch/javasoft/jbase/concurrent/MultiplexedAppendTable.html" title="class in ch.javasoft.jbase.concurrent"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?ch/javasoft/jbase/concurrent/ConcurrentTable.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="ConcurrentTable.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
ch.javasoft.jbase.concurrent</FONT>
<BR>
Class ConcurrentTable&lt;E&gt;</H2>
<PRE>
<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html" title="class or interface in java.lang">java.lang.Object</A>
  <IMG SRC="../../../../resources/inherit.gif" ALT="extended by "><B>ch.javasoft.jbase.concurrent.ConcurrentTable&lt;E&gt;</B>
</PRE>
<DL>
<DT><B>All Implemented Interfaces:</B> <DD><A HREF="../../../../ch/javasoft/jbase/Table.html" title="interface in ch.javasoft.jbase">Table</A>&lt;E&gt;</DD>
</DL>
<HR>
<DL>
<DT><PRE>public class <A HREF="../../../../src-html/ch/javasoft/jbase/concurrent/ConcurrentTable.html#line.57"><B>ConcurrentTable&lt;E&gt;</B></A><DT>extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A><DT>implements <A HREF="../../../../ch/javasoft/jbase/Table.html" title="interface in ch.javasoft.jbase">Table</A>&lt;E&gt;</DL>
</PRE>

<P>
The <code>ConcurrentTable</code> creates a thread-safe table for concurrent 
 use. Concurrent tables allow multiple concurrent readers, writing requires 
 exclusive table access. The access control is handled with a
 <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/util/concurrent/locks/ReentrantReadWriteLock.html" title="class or interface in java.util.concurrent.locks"><CODE>read/write lock</CODE></A>.
 <p>
 A read copy is created for every thread when the table is accessed for 
 reading the first time. If it is accessed for writing, exclusive access to 
 the main table is required. If the table is closed, only the read copy will 
 be closed, unless the owner of the table (mostly the thread which created 
 this instance) closes it. If the owner closes the table, every subsequent 
 table access will cause an exception, also for read access to read copy 
 tables. Multiple close calls do not cause an exception.
<P>

<P>
<HR>

<P>

<!-- ======== CONSTRUCTOR SUMMARY ======== -->

<A NAME="constructor_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Constructor Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html#ConcurrentTable(T)">ConcurrentTable</A></B>(T&nbsp;table)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Creates a table owned by the current thread.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html#ConcurrentTable(T, java.lang.Thread)">ConcurrentTable</A></B>(T&nbsp;table,
                               <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Thread.html" title="class or interface in java.lang">Thread</A>&nbsp;owner)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Creates a table owned by the specified thread.</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html#add(E)">add</A></B>(<A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html" title="type parameter in ConcurrentTable">E</A>&nbsp;entity)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Adds a new entity to the table.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html#close(boolean)">close</A></B>(boolean&nbsp;erase)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Closes this table.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html#flush()">flush</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Flush ensures that all write operations are persisted.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html" title="type parameter in ConcurrentTable">E</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html#get(int)">get</A></B>(int&nbsp;index)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the entity at the given position.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;<A HREF="../../../../ch/javasoft/jbase/Table.html" title="interface in ch.javasoft.jbase">Table</A>&lt;<A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html" title="type parameter in ConcurrentTable">E</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html#getReadTable(boolean)">getReadTable</A></B>(boolean&nbsp;forceCreate)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/util/concurrent/locks/ReadWriteLock.html" title="class or interface in java.util.concurrent.locks">ReadWriteLock</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html#getReadWriteLock()">getReadWriteLock</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the read/write lock which controls access to read and write
 methods of this table</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html#isOwner()">isOwner</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html#remove(int)">remove</A></B>(int&nbsp;index)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Removes the entity at the given position from the table.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html#removeAll()">removeAll</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Closes this table.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html#set(int, E)">set</A></B>(int&nbsp;index,
       <A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html" title="type parameter in ConcurrentTable">E</A>&nbsp;entity)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Replaces the entity at the given position by the specified
 entity.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html#size()">size</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the size of the table, i.e.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html#swap(int, int)">swap</A></B>(int&nbsp;indexA,
         int&nbsp;indexB)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Swaps the two entities specified by their index.</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#clone()" title="class or interface in java.lang">clone</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#equals(java.lang.Object)" title="class or interface in java.lang">equals</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#finalize()" title="class or interface in java.lang">finalize</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#getClass()" title="class or interface in java.lang">getClass</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#hashCode()" title="class or interface in java.lang">hashCode</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#notify()" title="class or interface in java.lang">notify</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#notifyAll()" title="class or interface in java.lang">notifyAll</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#toString()" title="class or interface in java.lang">toString</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#wait()" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#wait(long)" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#wait(long, int)" title="class or interface in java.lang">wait</A></CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ========= CONSTRUCTOR DETAIL ======== -->

<A NAME="constructor_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Constructor Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="ConcurrentTable(ch.javasoft.jbase.Table)"><!-- --></A><A NAME="ConcurrentTable(T)"><!-- --></A><H3>
ConcurrentTable</H3>
<PRE>
public <A HREF="../../../../src-html/ch/javasoft/jbase/concurrent/ConcurrentTable.html#line.72"><B>ConcurrentTable</B></A>(T&nbsp;table)
                throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD>Creates a table owned by the current thread. The owner is the thread 
 which definitely closes this table. All other threads close only their
 read copies of the table. After closing the table by the owner, all other
 tables are also closed and subsequent accesses will fail.
<P>
<DL>

<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></CODE></DL>
</DL>
<HR>

<A NAME="ConcurrentTable(ch.javasoft.jbase.Table,java.lang.Thread)"><!-- --></A><A NAME="ConcurrentTable(T, java.lang.Thread)"><!-- --></A><H3>
ConcurrentTable</H3>
<PRE>
public <A HREF="../../../../src-html/ch/javasoft/jbase/concurrent/ConcurrentTable.html#line.81"><B>ConcurrentTable</B></A>(T&nbsp;table,
                       <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Thread.html" title="class or interface in java.lang">Thread</A>&nbsp;owner)
                throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD>Creates a table owned by the specified thread. The owner is the thread 
 which definitely closes this table. All other threads close only their
 read copies of the table. After closing the table by the owner, all other
 tables are also closed and subsequent accesses will fail.
<P>
<DL>

<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></CODE></DL>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="getReadWriteLock()"><!-- --></A><H3>
getReadWriteLock</H3>
<PRE>
protected <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/util/concurrent/locks/ReadWriteLock.html" title="class or interface in java.util.concurrent.locks">ReadWriteLock</A> <A HREF="../../../../src-html/ch/javasoft/jbase/concurrent/ConcurrentTable.html#line.91"><B>getReadWriteLock</B></A>()</PRE>
<DL>
<DD>Returns the read/write lock which controls access to read and write
 methods of this table
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getReadTable(boolean)"><!-- --></A><H3>
getReadTable</H3>
<PRE>
protected <A HREF="../../../../ch/javasoft/jbase/Table.html" title="interface in ch.javasoft.jbase">Table</A>&lt;<A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html" title="type parameter in ConcurrentTable">E</A>&gt; <A HREF="../../../../src-html/ch/javasoft/jbase/concurrent/ConcurrentTable.html#line.100"><B>getReadTable</B></A>(boolean&nbsp;forceCreate)
                         throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></CODE></DL>
</DD>
</DL>
<HR>

<A NAME="isOwner()"><!-- --></A><H3>
isOwner</H3>
<PRE>
protected boolean <A HREF="../../../../src-html/ch/javasoft/jbase/concurrent/ConcurrentTable.html#line.120"><B>isOwner</B></A>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="add(java.lang.Object)"><!-- --></A><A NAME="add(E)"><!-- --></A><H3>
add</H3>
<PRE>
public int <A HREF="../../../../src-html/ch/javasoft/jbase/concurrent/ConcurrentTable.html#line.123"><B>add</B></A>(<A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html" title="type parameter in ConcurrentTable">E</A>&nbsp;entity)
        throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../ch/javasoft/jbase/Table.html#add(E)">Table</A></CODE></B></DD>
<DD>Adds a new entity to the table. The index of the added entity
 is at end of table, i.e. <A HREF="../../../../ch/javasoft/jbase/Table.html#size()"><CODE>size</CODE></A>-1 after adding
 the new entity.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../ch/javasoft/jbase/Table.html#add(E)">add</A></CODE> in interface <CODE><A HREF="../../../../ch/javasoft/jbase/Table.html" title="interface in ch.javasoft.jbase">Table</A>&lt;<A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html" title="type parameter in ConcurrentTable">E</A>&gt;</CODE></DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>the position of the added entity, i.e. size-1
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></CODE></DL>
</DD>
</DL>
<HR>

<A NAME="close(boolean)"><!-- --></A><H3>
close</H3>
<PRE>
public void <A HREF="../../../../src-html/ch/javasoft/jbase/concurrent/ConcurrentTable.html#line.134"><B>close</B></A>(boolean&nbsp;erase)
           throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../ch/javasoft/jbase/Table.html#close(boolean)">Table</A></CODE></B></DD>
<DD>Closes this table. Pending write operations are <A HREF="../../../../ch/javasoft/jbase/Table.html#flush()"><CODE>flushed</CODE></A>, 
 and underlying files are closed. Subsequent access to the table
 is not allowed and causes exceptions. Multiple calls to this 
 <tt>close</tt> method do not cause any exceptions.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../ch/javasoft/jbase/Table.html#close(boolean)">close</A></CODE> in interface <CODE><A HREF="../../../../ch/javasoft/jbase/Table.html" title="interface in ch.javasoft.jbase">Table</A>&lt;<A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html" title="type parameter in ConcurrentTable">E</A>&gt;</CODE></DL>
</DD>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></CODE></DL>
</DD>
</DL>
<HR>

<A NAME="flush()"><!-- --></A><H3>
flush</H3>
<PRE>
public void <A HREF="../../../../src-html/ch/javasoft/jbase/concurrent/ConcurrentTable.html#line.161"><B>flush</B></A>()
           throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../ch/javasoft/jbase/Table.html#flush()">Table</A></CODE></B></DD>
<DD>Flush ensures that all write operations are persisted. Writing
 to files ore databases might involve caches (operating system 
 caches or application caches). Calling this method enforces that
 all cached data is written to the underlying layer(s).
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../ch/javasoft/jbase/Table.html#flush()">flush</A></CODE> in interface <CODE><A HREF="../../../../ch/javasoft/jbase/Table.html" title="interface in ch.javasoft.jbase">Table</A>&lt;<A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html" title="type parameter in ConcurrentTable">E</A>&gt;</CODE></DL>
</DD>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></CODE></DL>
</DD>
</DL>
<HR>

<A NAME="get(int)"><!-- --></A><H3>
get</H3>
<PRE>
public <A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html" title="type parameter in ConcurrentTable">E</A> <A HREF="../../../../src-html/ch/javasoft/jbase/concurrent/ConcurrentTable.html#line.172"><B>get</B></A>(int&nbsp;index)
      throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../ch/javasoft/jbase/Table.html#get(int)">Table</A></CODE></B></DD>
<DD>Returns the entity at the given position. Note that (row) indices
 might change if entities are added or removed.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../ch/javasoft/jbase/Table.html#get(int)">get</A></CODE> in interface <CODE><A HREF="../../../../ch/javasoft/jbase/Table.html" title="interface in ch.javasoft.jbase">Table</A>&lt;<A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html" title="type parameter in ConcurrentTable">E</A>&gt;</CODE></DL>
</DD>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></CODE></DL>
</DD>
</DL>
<HR>

<A NAME="removeAll()"><!-- --></A><H3>
removeAll</H3>
<PRE>
public void <A HREF="../../../../src-html/ch/javasoft/jbase/concurrent/ConcurrentTable.html#line.184"><B>removeAll</B></A>()
               throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../ch/javasoft/jbase/Table.html#removeAll()">Table</A></CODE></B></DD>
<DD>Closes this table. Pending write operations are <A HREF="../../../../ch/javasoft/jbase/Table.html#flush()"><CODE>flushed</CODE></A>, 
 and underlying files are closed. Subsequent access to the table
 is not allowed and causes exceptions. Multiple calls to this 
 <tt>close</tt> method do not cause any exceptions.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../ch/javasoft/jbase/Table.html#removeAll()">removeAll</A></CODE> in interface <CODE><A HREF="../../../../ch/javasoft/jbase/Table.html" title="interface in ch.javasoft.jbase">Table</A>&lt;<A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html" title="type parameter in ConcurrentTable">E</A>&gt;</CODE></DL>
</DD>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></CODE></DL>
</DD>
</DL>
<HR>

<A NAME="remove(int)"><!-- --></A><H3>
remove</H3>
<PRE>
public void <A HREF="../../../../src-html/ch/javasoft/jbase/concurrent/ConcurrentTable.html#line.195"><B>remove</B></A>(int&nbsp;index)
            throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../ch/javasoft/jbase/Table.html#remove(int)">Table</A></CODE></B></DD>
<DD>Removes the entity at the given position from the table. If
 this was the last entity, it is just removed. If it is another
 (not the last) row, the entity at the last row is moved to
 the specified position of the entity to remove.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../ch/javasoft/jbase/Table.html#remove(int)">remove</A></CODE> in interface <CODE><A HREF="../../../../ch/javasoft/jbase/Table.html" title="interface in ch.javasoft.jbase">Table</A>&lt;<A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html" title="type parameter in ConcurrentTable">E</A>&gt;</CODE></DL>
</DD>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></CODE></DL>
</DD>
</DL>
<HR>

<A NAME="set(int,java.lang.Object)"><!-- --></A><A NAME="set(int, E)"><!-- --></A><H3>
set</H3>
<PRE>
public void <A HREF="../../../../src-html/ch/javasoft/jbase/concurrent/ConcurrentTable.html#line.206"><B>set</B></A>(int&nbsp;index,
                <A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html" title="type parameter in ConcurrentTable">E</A>&nbsp;entity)
         throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../ch/javasoft/jbase/Table.html#set(int, E)">Table</A></CODE></B></DD>
<DD>Replaces the entity at the given position by the specified
 entity.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../ch/javasoft/jbase/Table.html#set(int, E)">set</A></CODE> in interface <CODE><A HREF="../../../../ch/javasoft/jbase/Table.html" title="interface in ch.javasoft.jbase">Table</A>&lt;<A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html" title="type parameter in ConcurrentTable">E</A>&gt;</CODE></DL>
</DD>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></CODE></DL>
</DD>
</DL>
<HR>

<A NAME="swap(int, int)"><!-- --></A><H3>
swap</H3>
<PRE>
public void <A HREF="../../../../src-html/ch/javasoft/jbase/concurrent/ConcurrentTable.html#line.217"><B>swap</B></A>(int&nbsp;indexA,
                 int&nbsp;indexB)
          throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../ch/javasoft/jbase/Table.html#swap(int, int)">Table</A></CODE></B></DD>
<DD>Swaps the two entities specified by their index.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../ch/javasoft/jbase/Table.html#swap(int, int)">swap</A></CODE> in interface <CODE><A HREF="../../../../ch/javasoft/jbase/Table.html" title="interface in ch.javasoft.jbase">Table</A>&lt;<A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html" title="type parameter in ConcurrentTable">E</A>&gt;</CODE></DL>
</DD>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></CODE></DL>
</DD>
</DL>
<HR>

<A NAME="size()"><!-- --></A><H3>
size</H3>
<PRE>
public int <A HREF="../../../../src-html/ch/javasoft/jbase/concurrent/ConcurrentTable.html#line.228"><B>size</B></A>()
         throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../ch/javasoft/jbase/Table.html#size()">Table</A></CODE></B></DD>
<DD>Returns the size of the table, i.e. the number of rows or entities.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../ch/javasoft/jbase/Table.html#size()">size</A></CODE> in interface <CODE><A HREF="../../../../ch/javasoft/jbase/Table.html" title="interface in ch.javasoft.jbase">Table</A>&lt;<A HREF="../../../../ch/javasoft/jbase/concurrent/ConcurrentTable.html" title="type parameter in ConcurrentTable">E</A>&gt;</CODE></DL>
</DD>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></CODE></DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/ConcurrentTable.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;PREV CLASS&nbsp;
&nbsp;<A HREF="../../../../ch/javasoft/jbase/concurrent/MultiplexedAppendTable.html" title="class in ch.javasoft.jbase.concurrent"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?ch/javasoft/jbase/concurrent/ConcurrentTable.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="ConcurrentTable.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
